typedef struct {
    int rfd;
    int wfd;
} _daveOSserialType;
typedef long unsigned int size_t;
typedef int wchar_t;

typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef struct
{
  long __val[2];
} __quad_t;
typedef struct
{
  __u_long __val[2];
} __u_quad_t;
 typedef __u_quad_t __dev_t;
 typedef unsigned int __uid_t;
 typedef unsigned int __gid_t;
 typedef unsigned long int __ino_t;
 typedef __u_quad_t __ino64_t;
 typedef unsigned int __mode_t;
 typedef unsigned int __nlink_t;
 typedef long int __off_t;
 typedef __quad_t __off64_t;
 typedef int __pid_t;
 typedef struct { int __val[2]; } __fsid_t;
 typedef long int __clock_t;
 typedef unsigned long int __rlim_t;
 typedef __u_quad_t __rlim64_t;
 typedef unsigned int __id_t;
 typedef long int __time_t;
 typedef unsigned int __useconds_t;
 typedef long int __suseconds_t;
 typedef int __daddr_t;
 typedef int __key_t;
 typedef int __clockid_t;
 typedef void * __timer_t;
 typedef long int __blksize_t;
 typedef long int __blkcnt_t;
 typedef __quad_t __blkcnt64_t;
 typedef unsigned long int __fsblkcnt_t;
 typedef __u_quad_t __fsblkcnt64_t;
 typedef unsigned long int __fsfilcnt_t;
 typedef __u_quad_t __fsfilcnt64_t;
 typedef int __fsword_t;
 typedef int __ssize_t;
 typedef long int __syscall_slong_t;
 typedef unsigned long int __syscall_ulong_t;
typedef __off64_t __loff_t;
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
 typedef int __intptr_t;
 typedef unsigned int __socklen_t;
union wait
  {
    int w_status;
    struct
      {
 unsigned int __w_termsig:7;
 unsigned int __w_coredump:1;
 unsigned int __w_retcode:8;
 unsigned int:16;


      } __wait_terminated;
    struct
      {

 unsigned int __w_stopval:8;
 unsigned int __w_stopsig:8;
 unsigned int:16;






      } __wait_stopped;
  };

typedef struct
  {
    int quot;
    int rem;
  } div_t;

typedef struct
  {
    long int quot;
    long int rem;
  } ldiv_t;







 typedef struct
  {
    long long int quot;
    long long int rem;
  } lldiv_t;


extern size_t __ctype_get_mb_cur_max (void) ;

extern double atof (const char *__nptr)
     ;
extern int atoi (const char *__nptr)
     ;
extern long int atol (const char *__nptr)
     ;


 extern long long int atoll (const char *__nptr)
     ;


extern double strtod (const char * __nptr,
        char ** __endptr)
     ;


extern float strtof (const char * __nptr,
       char ** __endptr) ;
extern long double strtold (const char * __nptr,
       char ** __endptr)
     ;


extern long int strtol (const char * __nptr,
   char ** __endptr, int __base)
     ;
extern unsigned long int strtoul (const char * __nptr,
      char ** __endptr, int __base)
     ;



extern long long int strtoll (const char * __nptr,
         char ** __endptr, int __base)
     ;

extern unsigned long long int strtoull (const char * __nptr,
     char ** __endptr, int __base)
     ;

extern char *l64a (long int __n) ;
extern long int a64l (const char *__s)
     ;

typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __ssize_t ssize_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;

typedef __clock_t clock_t;



typedef __time_t time_t;


typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef char int8_t;
typedef short int int16_t;
typedef int int32_t;
typedef unsigned char u_int8_t;
typedef unsigned short int u_int16_t;
typedef unsigned int u_int32_t;
typedef int register_t;
typedef int __sig_atomic_t;
typedef struct
  {
    unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
  } __sigset_t;
typedef __sigset_t sigset_t;
struct timespec
  {
    __time_t tv_sec;
    __syscall_slong_t tv_nsec;
  };
struct timeval
  {
    __time_t tv_sec;
    __suseconds_t tv_usec;
  };
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
  {
    __fd_mask __fds_bits[1024 / (8 * (int) sizeof (__fd_mask))];
  } fd_set;
typedef __fd_mask fd_mask;

extern int select (int __nfds, fd_set * __readfds,
     fd_set * __writefds,
     fd_set * __exceptfds,
     struct timeval * __timeout);
extern int pselect (int __nfds, fd_set * __readfds,
      fd_set * __writefds,
      fd_set * __exceptfds,
      const struct timespec * __timeout,
      const __sigset_t * __sigmask);

typedef __blksize_t blksize_t;
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;
typedef __fsfilcnt_t fsfilcnt_t;
typedef unsigned long int pthread_t;
union pthread_attr_t
{
  char __size[36];
  long int __align;
};
typedef union pthread_attr_t pthread_attr_t;
typedef struct __pthread_internal_slist
{
  struct __pthread_internal_slist *__next;
} __pthread_slist_t;
typedef union
{
  struct __pthread_mutex_s
  {
    int __lock;
    unsigned int __count;
    int __owner;
    int __kind;
    unsigned int __nusers;
    union
    {
      int __spins;
      __pthread_slist_t __list;
    };
  } __data;
  char __size[24];
  long int __align;
} pthread_mutex_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __futex;
    unsigned long long int __total_seq;
    unsigned long long int __wakeup_seq;
    unsigned long long int __woken_seq;
    void *__mutex;
    unsigned int __nwaiters;
    unsigned int __broadcast_seq;
  } __data;
  char __size[48];
  long long int __align;
} pthread_cond_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __nr_readers;
    unsigned int __readers_wakeup;
    unsigned int __writer_wakeup;
    unsigned int __nr_readers_queued;
    unsigned int __nr_writers_queued;
    unsigned char __flags;
    unsigned char __shared;
    unsigned char __pad1;
    unsigned char __pad2;
    int __writer;
  } __data;
  char __size[32];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[20];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;

extern long int random (void) ;
extern void srandom (unsigned int __seed) ;
extern char *initstate (unsigned int __seed, char *__statebuf,
   size_t __statelen) ;
extern char *setstate (char *__statebuf) ;
struct random_data
  {
    int32_t *fptr;
    int32_t *rptr;
    int32_t *state;
    int rand_type;
    int rand_deg;
    int rand_sep;
    int32_t *end_ptr;
  };
extern int random_r (struct random_data * __buf,
       int32_t * __result) ;
extern int srandom_r (unsigned int __seed, struct random_data *__buf)
     ;
extern int initstate_r (unsigned int __seed, char * __statebuf,
   size_t __statelen,
   struct random_data * __buf)
     ;
extern int setstate_r (char * __statebuf,
         struct random_data * __buf)
     ;





extern int rand (void) ;

extern void srand (unsigned int __seed) ;




extern int rand_r (unsigned int *__seed) ;







extern double drand48 (void) ;
extern double erand48 (unsigned short int __xsubi[3]) ;


extern long int lrand48 (void) ;
extern long int nrand48 (unsigned short int __xsubi[3])
     ;


extern long int mrand48 (void) ;
extern long int jrand48 (unsigned short int __xsubi[3])
     ;


extern void srand48 (long int __seedval) ;
extern unsigned short int *seed48 (unsigned short int __seed16v[3])
     ;
extern void lcong48 (unsigned short int __param[7]) ;





struct drand48_data
  {
    unsigned short int __x[3];
    unsigned short int __old_x[3];
    unsigned short int __c;
    unsigned short int __init;
    unsigned long long int __a;
  };


extern int drand48_r (struct drand48_data * __buffer,
        double * __result) ;
extern int erand48_r (unsigned short int __xsubi[3],
        struct drand48_data * __buffer,
        double * __result) ;


extern int lrand48_r (struct drand48_data * __buffer,
        long int * __result)
     ;
extern int nrand48_r (unsigned short int __xsubi[3],
        struct drand48_data * __buffer,
        long int * __result)
     ;


extern int mrand48_r (struct drand48_data * __buffer,
        long int * __result)
     ;
extern int jrand48_r (unsigned short int __xsubi[3],
        struct drand48_data * __buffer,
        long int * __result)
     ;


extern int srand48_r (long int __seedval, struct drand48_data *__buffer)
     ;

extern int seed48_r (unsigned short int __seed16v[3],
       struct drand48_data *__buffer) ;

extern int lcong48_r (unsigned short int __param[7],
        struct drand48_data *__buffer)
     ;









extern void *malloc (size_t __size) ;

extern void *calloc (size_t __nmemb, size_t __size)
     ;










extern void *realloc (void *__ptr, size_t __size)
     ;

extern void free (void *__ptr) ;




extern void cfree (void *__ptr) ;

extern void *alloca (size_t __size) ;







extern void *valloc (size_t __size) ;




extern int posix_memalign (void **__memptr, size_t __alignment, size_t __size)
     ;

extern void abort (void) ;
extern int atexit (void (*__func) (void)) ;

extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg)
     ;

extern void exit (int __status) ;


extern void _Exit (int __status) ;


extern char *getenv (const char *__name) ;

extern int putenv (char *__string) ;
extern int setenv (const char *__name, const char *__value, int __replace)
     ;
extern int unsetenv (const char *__name) ;
extern int clearenv (void) ;
extern char *mktemp (char *__template) ;
extern int mkstemp (char *__template) ;
extern int mkstemps (char *__template, int __suffixlen) ;
extern char *mkdtemp (char *__template) ;

extern int system (const char *__command) ;

extern char *realpath (const char * __name,
         char * __resolved) ;
typedef int (*__compar_fn_t) (const void *, const void *);

extern void *bsearch (const void *__key, const void *__base,
        size_t __nmemb, size_t __size, __compar_fn_t __compar)
     ;
extern void qsort (void *__base, size_t __nmemb, size_t __size,
     __compar_fn_t __compar) ;
extern int abs (int __x) ;
extern long int labs (long int __x) ;

 extern long long int llabs (long long int __x)
     ;

extern div_t div (int __numer, int __denom)
     ;
extern ldiv_t ldiv (long int __numer, long int __denom)
     ;


 extern lldiv_t lldiv (long long int __numer,
        long long int __denom)
     ;

extern char *ecvt (double __value, int __ndigit, int * __decpt,
     int * __sign) ;
extern char *fcvt (double __value, int __ndigit, int * __decpt,
     int * __sign) ;
extern char *gcvt (double __value, int __ndigit, char *__buf)
     ;
extern char *qecvt (long double __value, int __ndigit,
      int * __decpt, int * __sign)
     ;
extern char *qfcvt (long double __value, int __ndigit,
      int * __decpt, int * __sign)
     ;
extern char *qgcvt (long double __value, int __ndigit, char *__buf)
     ;
extern int ecvt_r (double __value, int __ndigit, int * __decpt,
     int * __sign, char * __buf,
     size_t __len) ;
extern int fcvt_r (double __value, int __ndigit, int * __decpt,
     int * __sign, char * __buf,
     size_t __len) ;
extern int qecvt_r (long double __value, int __ndigit,
      int * __decpt, int * __sign,
      char * __buf, size_t __len)
     ;
extern int qfcvt_r (long double __value, int __ndigit,
      int * __decpt, int * __sign,
      char * __buf, size_t __len)
     ;

extern int mblen (const char *__s, size_t __n) ;
extern int mbtowc (wchar_t * __pwc,
     const char * __s, size_t __n) ;
extern int wctomb (char *__s, wchar_t __wchar) ;
extern size_t mbstowcs (wchar_t * __pwcs,
   const char * __s, size_t __n) ;
extern size_t wcstombs (char * __s,
   const wchar_t * __pwcs, size_t __n)
     ;

extern int rpmatch (const char *__response) ;
extern int getsubopt (char ** __optionp,
        char *const * __tokens,
        char ** __valuep)
     ;
extern int getloadavg (double __loadavg[], int __nelem)
     ;

 char * daveStrerror(int code);
 void daveStringCopy(char * intString, char * extString);
 void daveSetDebug(int nDebug);
 int daveGetDebug(void);
typedef struct _daveConnection daveConnection;
typedef struct _daveInterface daveInterface;
typedef struct {
    unsigned char * header;
    unsigned char * param;
    unsigned char * data;
    unsigned char * udata;
    int hlen;
    int plen;
    int dlen;
    int udlen;
} PDU;
struct _daveInterface {
    int _timeout;
};
 daveInterface * daveNewInterface(_daveOSserialType nfd, char * nname, int localMPI, int protocol, int speed);
struct _daveConnection {
    int AnswLen;
    unsigned char * resultPointer;
    int maxPDUlength;
};
 daveConnection * daveNewConnection(daveInterface * di, int MPI,int rack, int slot);
typedef struct {
    unsigned char type[2];
    unsigned short count;
} daveBlockTypeEntry;
typedef struct {
    unsigned short number;
    unsigned char type[2];
} daveBlockEntry;
 int daveGetResponse(daveConnection * dc);
 int daveSendMessage(daveConnection * dc, PDU * p);
 void _daveDumpPDU(PDU * p);
 void _daveDump(char * name,unsigned char*b,int len);
 char * daveBlockName(unsigned char bn);
 char * daveAreaName(unsigned char n);
 short daveSwapIed_16(short ff);
 int daveSwapIed_32(int ff);
 float daveGetFloatAt(daveConnection * dc, int pos);
 float toPLCfloat(float ff);
 int daveToPLCfloat(float ff);
 int daveGetS8from(unsigned char *b);
 int daveGetU8from(unsigned char *b);
 int daveGetS16from(unsigned char *b);
 int daveGetU16from(unsigned char *b);
 int daveGetS32from(unsigned char *b);
 unsigned int daveGetU32from(unsigned char *b);
 float daveGetFloatfrom(unsigned char *b);
 int daveGetS8(daveConnection * dc);
 int daveGetU8(daveConnection * dc);
 int daveGetS16(daveConnection * dc);
 int daveGetU16(daveConnection * dc);
 int daveGetS32(daveConnection * dc);
 unsigned int daveGetU32(daveConnection * dc);
 float daveGetFloat(daveConnection * dc);
 int daveGetS8At(daveConnection * dc, int pos);
 int daveGetU8At(daveConnection * dc, int pos);
 int daveGetS16At(daveConnection * dc, int pos);
 int daveGetU16At(daveConnection * dc, int pos);
 int daveGetS32At(daveConnection * dc, int pos);
 unsigned int daveGetU32At(daveConnection * dc, int pos);
 unsigned char * davePut8(unsigned char *b,int v);
 unsigned char * davePut16(unsigned char *b,int v);
 unsigned char * davePut32(unsigned char *b,int v);
 unsigned char * davePutFloat(unsigned char *b,float v);
 void davePut8At(unsigned char *b, int pos, int v);
 void davePut16At(unsigned char *b, int pos, int v);
 void davePut32At(unsigned char *b, int pos, int v);
 void davePutFloatAt(unsigned char *b,int pos, float v);
 float daveGetSeconds(daveConnection * dc);
 float daveGetSecondsAt(daveConnection * dc, int pos);
 int daveGetCounterValue(daveConnection * dc);
 int daveGetCounterValueAt(daveConnection * dc,int pos);
 void _daveConstructUpload(PDU *p,char blockType, int blockNr);
 void _daveConstructDoUpload(PDU * p, int uploadID);
 void _daveConstructEndUpload(PDU * p, int uploadID);
 int daveGetOrderCode(daveConnection * dc,char * buf);
 int daveConnectPLC(daveConnection * dc);
 int daveReadBytes(daveConnection * dc, int area, int DB, int start, int len, void * buffer);
 int daveReadManyBytes(daveConnection * dc,int area, int DBnum, int start,int len, void * buffer);
 int daveWriteBytes(daveConnection * dc,int area, int DB, int start, int len, void * buffer);
 int daveWriteManyBytes(daveConnection * dc,int area, int DB, int start, int len, void * buffer);
 int daveReadBits(daveConnection * dc, int area, int DB, int start, int len, void * buffer);
 int daveWriteBits(daveConnection * dc,int area, int DB, int start, int len, void * buffer);
 int daveSetBit(daveConnection * dc,int area, int DB, int byteAdr, int bitAdr);
 int daveClrBit(daveConnection * dc,int area, int DB, int byteAdr, int bitAdr);
 int daveReadSZL(daveConnection * dc, int ID, int index, void * buf, int buflen);
 int daveListBlocksOfType(daveConnection * dc,unsigned char type,daveBlockEntry * buf);
 int daveListBlocks(daveConnection * dc,daveBlockTypeEntry * buf);
 int initUpload(daveConnection * dc,char blockType, int blockNr, int * uploadID);
 int doUpload(daveConnection*dc, int * more, unsigned char**buffer, int*len, int uploadID);
 int endUpload(daveConnection*dc, int uploadID);
 int daveGetProgramBlock(daveConnection * dc, int blockType, int number, char* buffer, int * length);
 int daveStop(daveConnection*dc);
 int daveStart(daveConnection*dc);
 int daveCopyRAMtoROM(daveConnection*dc);
 int daveForce200(daveConnection * dc, int area, int start, int val);
typedef struct {
    int error;
    int length;
    unsigned char * bytes;
} daveResult;
typedef struct {
    int numResults;
    daveResult * results;
} daveResultSet;
 void davePrepareReadRequest(daveConnection * dc, PDU *p);
 void daveAddVarToReadRequest(PDU *p, int area, int DBnum, int start, int bytes);
 int daveExecReadRequest(daveConnection * dc, PDU *p, daveResultSet * rl);
 int daveUseResult(daveConnection * dc, daveResultSet * rl, int n);
 void daveFreeResults(daveResultSet * rl);
 void daveAddBitVarToReadRequest(PDU *p, int area, int DBnum, int start, int byteCount);
 void davePrepareWriteRequest(daveConnection * dc, PDU *p);
 void daveAddVarToWriteRequest(PDU *p, int area, int DBnum, int start, int bytes, void * buffer);
 void daveAddBitVarToWriteRequest(PDU *p, int area, int DBnum, int start, int byteCount, void * buffer);
 int daveExecWriteRequest(daveConnection * dc, PDU *p, daveResultSet * rl);
 int daveInitAdapter(daveInterface * di);
 int daveConnectPLC(daveConnection * dc);
 int daveDisconnectPLC(daveConnection * dc);
 int daveDisconnectAdapter(daveInterface * di);
 int daveListReachablePartners(daveInterface * di,char * buf);
 void daveSetTimeout(daveInterface * di, int tmo);
 int daveGetTimeout(daveInterface * di);
 char * daveGetName(daveInterface * di);
 int daveGetMPIAdr(daveConnection * dc);
 int daveGetAnswLen(daveConnection * dc);
 int daveGetMaxPDULen(daveConnection * dc);
 daveResultSet * daveNewResultSet();
 void daveFree(void * dc);
 PDU * daveNewPDU();
 int daveGetErrorOfResult(daveResultSet *,int number);
 int daveForceDisconnectIBH(daveInterface * di, int src, int dest, int mpi);
 int daveResetIBH(daveInterface * di);
 int daveGetProgramBlock(daveConnection * dc, int blockType, int number, char* buffer, int * length);
 int daveReadPLCTime(daveConnection * dc);
 int daveSetPLCTime(daveConnection * dc,unsigned char * ts);
 int daveSetPLCTimeToSystime(daveConnection * dc);
 unsigned char daveToBCD(unsigned char i);
 unsigned char daveFromBCD(unsigned char i);
int openSocket(const int port, const char * peer);
int closeSocket(int h);
