import cffi

ffi = cffi.FFI()

ffi.cdef("""struct s { int a; }; int foo(struct s);""")

lib = ffi.verify("""
struct s { int a; };
int foo(struct s x) {
    return x.a;
}
""")

def f(n):
    s = ffi.new("struct s *", [n])
    m = lib.foo(s[0])
    assert m == n


f(42)
print ffi.typeof(lib.foo)
