typedef struct {char c;} rfid_dev;
typedef struct {} serial_dev;

int serial_tx(serial_dev* d, uint8_t ch);
int serial_rx(serial_dev* d, uint8_t* ch);

int rfid_init(rfid_dev* d)
{
    serial_dev dummy;
    serial_tx(&dummy, 'I');
    serial_tx(&dummy, 'N');
    serial_tx(&dummy, 'I');
    serial_tx(&dummy, 'T');
    
    unsigned char c[2];
    serial_rx(&dummy, &c[0]);
    serial_rx(&dummy, &c[1]);
    if (c[0] != 'O' || c[1] != 'K')
    {
        return -1;
    }
    return 0;
}
