import cffi
ffi = cffi.FFI()
ffi.cdef(r'''
struct NVGcolor {
    union {
        float rgba[4];
        struct { float r,g,b,a; };
    };
};
''')
color = ffi.new('struct NVGcolor *')
print('raw ffi:', ffi.sizeof(color[0]), ffi.sizeof(color[0].rgba))

ffi.set_source('bug', None)
ffi.emit_python_code('bug.py')
from bug import ffi
color = ffi.new('struct NVGcolor *')
print('generated ffi:', ffi.sizeof(color[0]), ffi.sizeof(color[0].rgba))
