from cffi import FFI
ffi = FFI()
ffi.cdef("""
    void test_func(double *x, double *f, int nx, int mx,int func_num);
    void sphere_func (double *, double *, int , double *,double *, int); 
    void ellips_func(double *, double *, int , double *,double *, int); 
    void bent_cigar_func(double *, double *, int , double *,double *, int); 
    void discus_func(double *, double *, int , double *,double *, int);  
    void dif_powers_func(double *, double *, int , double *,double *, int);  
    void rosenbrock_func (double *, double *, int , double *,double *, int); 
    void schaffer_F7_func (double *, double *, int , double *,double *, int); 
    void ackley_func (double *, double *, int , double *,double *, int); 
    void rastrigin_func (double *, double *, int , double *,double *, int); 
    void weierstrass_func (double *, double *, int , double *,double *, int); 
    void griewank_func (double *, double *, int , double *,double *, int); 
    void schwefel_func (double *, double *, int , double *,double *, int); 
    void katsuura_func (double *, double *, int , double *,double *, int); 
    void bi_rastrigin_func (double *, double *, int , double *,double *, int); 
    void grie_rosen_func (double *, double *, int , double *,double *, int); 
    void escaffer6_func (double *, double *, int , double *,double *, int); 
    void step_rastrigin_func (double *, double *, int , double *,double *, int); 
    void cf01 (double *, double *, int , double *,double *, int); 
    void cf02 (double *, double *, int , double *,double *, int); 
    void cf03 (double *, double *, int , double *,double *, int); 
    void cf04 (double *, double *, int , double *,double *, int); 
    void cf05 (double *, double *, int , double *,double *, int); 
    void cf06 (double *, double *, int , double *,double *, int); 
    void cf07 (double *, double *, int , double *,double *, int); 
    void cf08 (double *, double *, int , double *,double *, int);

    void shiftfunc (double*,double*,int,double*);
    void rotatefunc (double*,double*,int, double*);
    void asyfunc (double *, double *x, int, double);
    void oszfunc (double *, double *, int);
    void cf_cal(double *, double *, int, double *,double *,double *,double *,int);

    double *OShift,*M,*y,*z,*x_bound;
    int ini_flag,n_flag,func_flag;
    """)
ffi.set_source('Problem1',
    """
    #include "2013_func.h"   
    """,
    sources=['2013_func.c'])
if __name__ == '__main__':
        ffi.compile(verbose = True)
##        ffi.compile(target="testProblem.*", verbose=True)

